IF NOT(EXISTS(SELECT * FROM  INFORMATION_SCHEMA.TABLES WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME='Game'))
BEGIN
create table Game(
	GameId int PRIMARY KEY,
	[Name] nvarchar(MAX) NOT NULL
);
END

IF NOT(EXISTS(SELECT * FROM  INFORMATION_SCHEMA.TABLES WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME='Rarity'))
BEGIN
create table Rarity
(
	RarityId int PRIMARY KEY,
	[Name] nvarchar(100) NOT NULL,
	GameId int FOREIGN KEY REFERENCES Game (GameId),
	UNIQUE ([Name], GameId)
);
END


IF NOT(EXISTS(SELECT * FROM  INFORMATION_SCHEMA.TABLES WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME='Category'))
BEGIN
create table Category
(
	CategoryId int PRIMARY KEY,
	[Name] nvarchar(100) NOT NULL,
	GameId int FOREIGN KEY REFERENCES Game (GameId),
	UNIQUE ([Name], GameId)
);
END

IF NOT(EXISTS(SELECT * FROM  INFORMATION_SCHEMA.TABLES WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME='Attribute'))
BEGIN
create table Attribute
(
	AttributeId int PRIMARY KEY,
	[Name] nvarchar(100) NOT NULL,
	GameId int FOREIGN KEY REFERENCES Game (GameId)
	UNIQUE ([Name], GameId)
);
END

IF NOT(EXISTS(SELECT * FROM  INFORMATION_SCHEMA.TABLES WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME='TypeCard'))
BEGIN
create table TypeCard
(
	TypeId int PRIMARY KEY,
	[Name] nvarchar(100) NOT NULL,
	GameId int FOREIGN KEY REFERENCES Game (GameId),
	UNIQUE ([Name], GameId)
);
END

IF NOT(EXISTS(SELECT * FROM  INFORMATION_SCHEMA.TABLES WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME='Card'))
BEGIN
create table [Card]
(
	CardId int IDENTITY PRIMARY KEY,
	PaperId nvarchar (100),
	GameId int NOT NULL FOREIGN KEY REFERENCES Game (GameId),
	[Name] nvarchar (MAX) NOT NULL,
	[Image] nvarchar (MAX) NOT NULL,
	RarityId int NOT NULL FOREIGN KEY REFERENCES Rarity (RarityId),
	--Category int NOT NULL FOREIGN KEY REFERENCES Category (CategoryId),
	--Attribute int NOT NULL FOREIGN KEY REFERENCES Attribute (AttributeId),
	--[Type] nvarchar (MAX) NOT NULL,
	Cost nvarchar (MAX) NOT NULL
);
END

IF NOT(EXISTS(SELECT * FROM  INFORMATION_SCHEMA.TABLES WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME='CardAttribute'))
BEGIN
create table CardAttribute
(
	CardAttributeId int IDENTITY PRIMARY KEY,
	AttributeId int FOREIGN KEY REFERENCES Attribute (AttributeId),
	CardId int FOREIGN KEY REFERENCES [Card] (CardId)
);
END

IF NOT(EXISTS(SELECT * FROM  INFORMATION_SCHEMA.TABLES WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME='CardsTypeCard'))
BEGIN
create table CardsTypeCard
(
	CardsTypeCardId int IDENTITY PRIMARY KEY,
	TypeId int FOREIGN KEY REFERENCES TypeCard (TypeId),
	CardId int FOREIGN KEY REFERENCES [Card] (CardId)
);
END

IF NOT(EXISTS(SELECT * FROM  INFORMATION_SCHEMA.TABLES WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME='CardCategory'))
BEGIN
create table CardCategory
(
	CardCategoryId int IDENTITY PRIMARY KEY,
	CategoryId int FOREIGN KEY REFERENCES Category (CategoryId),
	CardId int FOREIGN KEY REFERENCES [Card] (CardId)
);
END

IF NOT(EXISTS(SELECT * FROM  INFORMATION_SCHEMA.TABLES WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME='User'))
BEGIN
create table [User]
(
	UserId int IDENTITY PRIMARY KEY,
	UserName nvarchar(100) UNIQUE NOT NULL,
	[Password] nvarchar(MAX) NOT NULL,
	Email nvarchar(MAX) NOT NULL,
	[Role] int DEFAULT 2 NOT NULL
);
END

IF NOT(EXISTS(SELECT * FROM  INFORMATION_SCHEMA.TABLES WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME='Deck'))
BEGIN
create table Deck
(
	DeckId int IDENTITY PRIMARY KEY,
	GameId int NOT NULL FOREIGN KEY REFERENCES Game (GameId),
	CardCount int NOT NULL DEFAULT 0,
	[Name] nvarchar (MAX) NOT NULL,
	UserId int NOT NULL FOREIGN KEY REFERENCES [User](Userid)
);
END

IF NOT(EXISTS(SELECT * FROM  INFORMATION_SCHEMA.TABLES WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME='UserCard'))
BEGIN
create table UserCard
(
	UserCardId int IDENTITY PRIMARY KEY,
	UserId int NOT NULL FOREIGN KEY REFERENCES [User] (UserId),
	CardId int NOT NULL FOREIGN KEY REFERENCES [Card] (CardId),
	Copies int NOT NULL DEFAULT 1,
	GameId int NOT NULL FOREIGN KEY REFERENCES Game (GameId)
);
END

--IF NOT(EXISTS(SELECT * FROM  INFORMATION_SCHEMA.TABLES WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME='UserDeck'))
--BEGIN
--create table UserDeck
--(
--	UserDeckId int IDENTITY PRIMARY KEY,
--	UserId int NOT NULL FOREIGN KEY REFERENCES [User] (UserId),
--	DeckId int NOT NULL FOREIGN KEY REFERENCES Deck (DeckId),
--	GameId int NOT NULL FOREIGN KEY REFERENCES Game (GameId)
--);
--END

IF NOT(EXISTS(SELECT * FROM  INFORMATION_SCHEMA.TABLES WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME='DeckCard'))
BEGIN
create table DeckCard
(
	DeckCardId int IDENTITY PRIMARY KEY,
	DeckId int NOT NULL FOREIGN KEY REFERENCES Deck (DeckId),
	CardId int NOT NULL FOREIGN KEY REFERENCES [Card] (CardId),
	Copies int NOT NULL DEFAULT 1,
	GameId int NOT NULL FOREIGN KEY REFERENCES Game (GameId)
);
END